## imcode.server
Interface ImcmsServices

All Known Implementing Classes:
  DefaultImcmsServices, MockImcmsServices

    public interface ImcmsServices

Method Summary
`java.lang.String` `getAdminTemplate(java.lang.String adminTemplateName, UserDomainObject user, java.util.List tagsWithReplacements)`
`java.lang.String[][]` `getAllDocumentTypes(java.lang.String langPrefixStr)`
`CategoryMapper` `getCategoryMapper()`
`Config` `getConfig()`
`com.imcode.db.Database` `getDatabase()`
`java.text.Collator` `getDefaultLanguageCollator()`
`int` `getDocType(int meta_id)`
`DocumentMapper` `getDocumentMapper()`
`CachingFileLoader` `getFileCache()`
`ImcmsAuthenticatorAndUserAndRoleMapper` `getImcmsAuthenticatorAndUserAndRoleMapper()`
`java.io.File` `getIncludePath()`
`java.security.KeyStore` `getKeyStore()`
`LanguageMapper` `getLanguageMapper()`
`LocalizedMessageProvider` `getLocalizedMessageProvider()`
`ProcedureExecutor` `getProcedureExecutor()`
`RoleGetter` `getRoleGetter()`
`int` `getSessionCounter()`
`java.util.Date` `getSessionCounterDate()`
`java.lang.String` `getSessionCounterDateAsString()`
`SMTP` `getSMTP()`
`java.lang.Object` `getSpringBean(java.lang.String beanName)`
`SystemData` `getSystemData()`
`java.lang.String` `getTemplateFromDirectory(java.lang.String adminTemplateName, UserDomainObject user, java.util.List variables, java.lang.String directory)`
`TemplateMapper` `getTemplateMapper()`
`org.apache.velocity.VelocityContext` `getVelocityContext(UserDomainObject user)`
`org.apache.velocity.app.VelocityEngine` `getVelocityEngine(UserDomainObject user)`
`org.springframework.web.context.WebApplicationContext` `getWebApplicationContext()` Spring framework integration.
`void` `incrementSessionCounter()`
`void` `parsePage(ParserParameters paramsToParse, java.io.Writer out)`
`void` `setSessionCounter(int value)`
`void` `setSessionCounterDate(java.util.Date date)`
`void` `setSystemData(SystemData sd)`
`void` `updateMainLog(java.lang.String logMessage)`
`UserDomainObject` `verifyUser(java.lang.String login, java.lang.String password)` Verify a Internet/Intranet user.
`UserDomainObject` `verifyUserByIpOrDefault(java.lang.String remoteAddr)`

Method Detail

### verifyUser

    UserDomainObject verifyUser(java.lang.String login,
                                java.lang.String password)

  Verify a Internet/Intranet user. Data from any SQL Database.

### parsePage

    void parsePage(ParserParameters paramsToParse,
                   java.io.Writer out)
                   throws java.io.IOException

  Throws:
    `java.io.IOException`

### incrementSessionCounter

    void incrementSessionCounter()

### setSessionCounter

    void setSessionCounter(int value)

### setSessionCounterDate

    void setSessionCounterDate(java.util.Date date)

### getSessionCounterDate

    java.util.Date getSessionCounterDate()

### getAdminTemplate

    java.lang.String getAdminTemplate(java.lang.String adminTemplateName,
                                      UserDomainObject user,
                                      java.util.List tagsWithReplacements)

### getTemplateFromDirectory

    java.lang.String getTemplateFromDirectory(java.lang.String adminTemplateName,
                                              UserDomainObject user,
                                              java.util.List variables,
                                              java.lang.String directory)

### getDocType

    int getDocType(int meta_id)

### getSystemData

    SystemData getSystemData()

### setSystemData

    void setSystemData(SystemData sd)

### getAllDocumentTypes

    java.lang.String[][] getAllDocumentTypes(java.lang.String langPrefixStr)

### getSessionCounter

    int getSessionCounter()

### getSessionCounterDateAsString

    java.lang.String getSessionCounterDateAsString()

### updateMainLog

    void updateMainLog(java.lang.String logMessage)

### getDocumentMapper

    DocumentMapper getDocumentMapper()

### getImcmsAuthenticatorAndUserAndRoleMapper

    ImcmsAuthenticatorAndUserAndRoleMapper getImcmsAuthenticatorAndUserAndRoleMapper()

### getTemplateMapper

    TemplateMapper getTemplateMapper()

### getSMTP

    SMTP getSMTP()

### getIncludePath

    java.io.File getIncludePath()

### getDefaultLanguageCollator

    java.text.Collator getDefaultLanguageCollator()

### getVelocityEngine

    org.apache.velocity.app.VelocityEngine getVelocityEngine(UserDomainObject user)

### getVelocityContext

    org.apache.velocity.VelocityContext getVelocityContext(UserDomainObject user)

### getConfig

    Config getConfig()

### getKeyStore

    java.security.KeyStore getKeyStore()

### getDatabase

    com.imcode.db.Database getDatabase()

### getCategoryMapper

    CategoryMapper getCategoryMapper()

### getLanguageMapper

    LanguageMapper getLanguageMapper()

### getFileCache

    CachingFileLoader getFileCache()

### getRoleGetter

    RoleGetter getRoleGetter()

### getProcedureExecutor

    ProcedureExecutor getProcedureExecutor()

### verifyUserByIpOrDefault

    UserDomainObject verifyUserByIpOrDefault(java.lang.String remoteAddr)

### getLocalizedMessageProvider

    LocalizedMessageProvider getLocalizedMessageProvider()

### getWebApplicationContext

    org.springframework.web.context.WebApplicationContext getWebApplicationContext()

  Spring framework integration. Latter this will be refactored out.

### getSpringBean

    java.lang.Object getSpringBean(java.lang.String beanName)